package cn.skcks.jnr.sevenzip.hello;

import com.sun.jna.Library;
import com.sun.jna.Native;
import jakarta.annotation.PostConstruct;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class Hello {
    @PostConstruct
    void test(){
        context();
    };

    public interface HelloLib extends Library {
        HelloLib INSTANCE = Native.load(loadLib("/lib/win64/hello.dll"), HelloLib.class);

        int add(int a,int b);
    }

    @SneakyThrows
    synchronized static String loadLib(String resourcePath){
        String path = Native.extractFromResourcePath(resourcePath).getAbsolutePath();
        log.info("{}", path);
        return path;
    }

    @SneakyThrows
    public void context(){
        log.info("测试");
        HelloLib hello = HelloLib.INSTANCE;
        log.info("{}", hello.add(1,2));
    }
}
