package cn.skcks.jnr.sevenzip.sevenzip;

import com.sun.jna.Library;
import com.sun.jna.Native;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

@Slf4j
@ExtendWith(SpringExtension.class)
@SpringBootTest(classes = ApplicationTest.class)
public class SimpleTest {

    public interface HelloLib extends Library {
        HelloLib INSTANCE = Native.load(loadLib("/lib/win64/hello.dll"), HelloLib.class);

        int add(int a,int b);
    }

    @SneakyThrows
    synchronized static String loadLib(String resourcePath){
        String path = Native.extractFromResourcePath(resourcePath).getAbsolutePath();
        log.info("{}", path);
        return path;
    }

    @Test
    @SneakyThrows
    public void context(){
        log.info("测试");
        HelloLib hello = HelloLib.INSTANCE;
        log.info("{}", hello.add(1,2));
    }
}
